﻿
namespace Singleton
{
    enum DisplayMode
    {        
        MODE_PICTURE,
        MODE_INFO        
    }

    class Camera
    {
        InnerObject innerobj;
        DisplayMode displaymode;		
        IView[] views = new IView[2];
        public static Camera Singleton
        {
            get;
            private set;
        }
        static Camera()
        {
            Singleton = new Camera();
        }
        private Camera()
        {	
            innerobj = InnerObject.Singleton;
            displaymode = DisplayMode.MODE_PICTURE;
            views[(int)DisplayMode.MODE_INFO] = new InfoDisplay();
            views[(int)DisplayMode.MODE_PICTURE] = new PictureDisplay();
        }
        public void PutMemoryCard(MemoryCard memorycard)
        {
            innerobj.PutMemoryCard(memorycard);	
        }
        public void TakeAPicture(string subject)
        {	
            innerobj.StorePicture(subject);
        }
        public void View()
        {
            views[(int)displaymode].View();	
        }
        
        public void BeforePicture()
        {
            innerobj.MoveBefore();
        }
        public void NextPicture()
        {
            innerobj.MoveNext();
        }
        public void SetDisplayMode(DisplayMode displaymode)
        {
            this.displaymode = displaymode;
        }


    }
}
