﻿
namespace Singleton
{
    class Program
    {
        static void Main(string[] args)
        {
            Camera camera = Camera.Singleton;	
            MemoryCard mc = new MemoryCard();
            camera.PutMemoryCard(mc);
            
            camera.TakeAPicture("홍길동");            
            camera.TakeAPicture("강감찬");

            ViewMode(camera);
            ViewPicture(camera);            

            camera.BeforePicture();
            ViewMode(camera);
            ViewPicture(camera);
            
            camera.NextPicture();
            ViewPicture(camera);            
        }

        private static void ViewMode(Camera camera)
        {
            camera.SetDisplayMode(DisplayMode.MODE_INFO);
            camera.View();
        }

        private static void ViewPicture(Camera camera)
        {
            camera.SetDisplayMode(DisplayMode.MODE_PICTURE);
            camera.View();
        }
    }
}
